#include	"FoxPro.h"

#define	DWORD		Long
#define BOOL		long
#define T_HANDLE	long

#define TRUE	.T.
#define FALSE	.F.


#define	LIGHTWEIGHT_CLASS	[_LightWeightClass_]
*------------------------------------------------------------------------------------------
#if FALSE
	Priority:
		3	REALTIME_PRIORITY
		2	HIGH_PRIORITY_CLASS
		1	ABOVE_NORMAL_PRIORITY
		0	NORMAL_PRIORITY
		-1	BELOW_NORMAL_PRIORITY
		-2	IDLE_PRIORITY_CLASS


#endif
function ProcessPriority_Object(obj, Priority_New, Priority_Old)
	
	obj = null
	
	do case
	case pcount() < 2
		obj = createObject('ProcessPriority')
	
	otherwise
		obj = createObject('ProcessPriority', m.Priority_New, @m.Priority_Old)

	endcase
	return vartype(m.obj) = T_OBJECT
	
endfunc
*---------------------------------------------------------------------------

*===============================================================================
*===============================================================================
*===============================================================================

#define NORMAL_PRIORITY_CLASS             0x00000020
#define IDLE_PRIORITY_CLASS               0x00000040
#define HIGH_PRIORITY_CLASS               0x00000080
#define REALTIME_PRIORITY_CLASS           0x00000100

#define BELOW_NORMAL_PRIORITY_CLASS       0x00004000
#define ABOVE_NORMAL_PRIORITY_CLASS       0x00008000

*-------------------------------------------------------------------------------
define Class ProcessPriority as LIGHTWEIGHT_CLASS
	
	Priority_External_Saved	= null

*-------------------------------------------------------------------------------
hidden function init(Priority_External, Priority_External_Previous)

	local Success
	Success = TRUE
	
	declare BOOL SetPriorityClass in Kernel32 ;
		T_HANDLE hProcess, ;	&&  handle to process
		DWORD dwPriorityClass	&&	priority class
	
	declare DWORD GetPriorityClass in Kernel32 ;
 		T_HANDLE hProcess		&&	handle to process

	declare T_HANDLE GetCurrentProcess  in Kernel32

	with m.this
		do case
		case !m.Success
		
		case !DoDefault()
			assert FALSE
			Success = FALSE
		
		case !.Priority_Save()
			assert FALSE
			Success = FALSE
			
		case empty(pcount())
		
		case !.Priority_Set(m.Priority_External, @m.Priority_External_Previous)
			assert FALSE
			Success = FALSE
	
		endcase
		
	endwith
	
	return m.Success
endfunc
*-------------------------------------------------------------------------------
hidden function Destroy()
	=m.this.Priority_Reset()
	return DoDefault()
endfunc
*-------------------------------------------------------------------------------
function Priority_set(Priority_External, Priority_External_old)

	local Success
	Success = TRUE
	
	local Priority_Internal
	
	do case
	case !m.Success
	
	case !.Priority_External_Internal(m.Priority_External, @m.Priority_Internal)
		assert FALSE
		Success = FALSE
		
	case !m.this.Priority_get(@m.Priority_External_old)
		assert FALSE
		Success = FALSE
	
	case m.Priority_External = m.Priority_External_old
	
	case empty(SetPriorityClass(GetCurrentProcess(), m.Priority_Internal))
		assert FALSE
		Success = FALSE
	
	endcase
	
	return m.Success
		
endfunc
*-------------------------------------------------------------------------------
function Priority_get(Priority_External)
	
	local Success
	Success = TRUE
	
	local Priority_Internal
	
	with m.this
		
		Priority_Internal = GetPriorityClass(GetCurrentProcess())
		
		do case
		case !m.Success
		
		case empty(m.Priority_Internal)
			assert FALSE
			Success = FALSE
		
		case !.Priority_Internal_External(m.Priority_Internal, @m.Priority_External)
			assert FALSE
			Success = FALSE
		
		endcase
		
	endwith
	
	return m.Success

endfunc
*-------------------------------------------------------------------------------
function Priority_Save(Priority_External)
	
	local Success
	Success = TRUE

	with m.this
	
		do case
		case !m.Success
		
		case !.Priority_get(@m.Priority_External)
			assert FALSE
			Success = FALSE
			
		case !isnull(.Priority_External_Saved)
			assert FALSE
			Success = FALSE
		
		case !.AddProperty('Priority_External_Saved', m.Priority_External)
			assert FALSE
			Success = FALSE
		
		endcase
	
	endwith
	
	return m.Success
		
endfunc
*-------------------------------------------------------------------------------
function Priority_Reset()
	
	local Success
	Success = TRUE
	
	with m.this
		
		do case
		case !m.Success
		
		case isnull(.Priority_External_Saved)
			assert FALSE
			Success = FALSE
		
		case !.Priority_Set(.Priority_External_Saved)
			assert FALSE
			Success = FALSE
		
		case !.AddProperty('Priority_External_Saved', null)
			assert FALSE
			Success = FALSE
		
		endcase
		
	endwith
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
hidden function Priority_External_Internal(Priority_External, Priority_Internal)

	local Success
	Success = TRUE
	
	do case
	case !m.Success
	
	case empty(m.Priority_External)
		Priority_Internal	= NORMAL_PRIORITY_CLASS
	
	case !inlist(vartype(m.Priority_External), T_NUMERIC)
		assert FALSE
		Success = FALSE
	
	case !inlist(m.Priority_External, -2, -1, 0, 1, 2, 3)
		assert FALSE
		Success = FALSE
		
	case m.Priority_External = -2
		Priority_Internal = IDLE_PRIORITY_CLASS
	
	case m.Priority_External = -1
		Priority_Internal = BELOW_NORMAL_PRIORITY_CLASS 
	
	case m.Priority_External = 0
		Priority_Internal = NORMAL_PRIORITY_CLASS
	
	case m.Priority_External = 1
		Priority_Internal = ABOVE_NORMAL_PRIORITY_CLASS
	
	case m.Priority_External = 2
		Priority_Internal = HIGH_PRIORITY_CLASS
	
	case m.Priority_External = 3
		Priority_Internal = REALTIME_PRIORITY_CLASS
	
	otherwise
		Success = FALSE
		assert FALSE
		
	endcase
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
hidden function Priority_Internal_External(Priority_Internal, Priority_External)

	local Success
	Success = TRUE
	
	do case
	case !m.Success
	
	case m.Priority_Internal = IDLE_PRIORITY_CLASS
		Priority_External = -2
	
	case m.Priority_Internal = BELOW_NORMAL_PRIORITY_CLASS 
		Priority_External = -1
	
	case m.Priority_Internal = NORMAL_PRIORITY_CLASS
		Priority_External = 0
	
	case m.Priority_Internal = ABOVE_NORMAL_PRIORITY_CLASS
		Priority_External = 1
	
	case m.Priority_Internal = HIGH_PRIORITY_CLASS
		Priority_External = 2
	
	case m.Priority_Internal = REALTIME_PRIORITY_CLASS
		Priority_External = 3
	
	otherwise
		Success = FALSE
		assert FALSE
		
	endcase
	
	return m.Success
	
endfunc
*-------------------------------------------------------------------------------
enddefine

*===============================================================================
*===============================================================================
*===============================================================================

*================================================================================
define class LIGHTWEIGHT_CLASS as Cursor

	hidden	alias, buffermodeoverride, ClassLibrary, Comment, ;
			CursorSource, Database, Exclusive, Filter, NoDataOnLoad, ;
			Order, ReadOnly, Tag

enddefine
*================================================================================\